# -*- coding: utf-8 -*-
"""
Created on Fri Feb 19 17:46:14 2021

@author: subrata
"""
from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd
from matplotlib.dates import DateFormatter
import matplotlib.ticker as ticker
from datetime import datetime
from scipy.optimize import curve_fit
import scipy.io
import scipy.linalg
from scipy.stats import gompertz
#from sklearn.metrics import r2_score
from scipy.signal import savgol_filter

data=np.loadtxt('china_data.txt',float)
#df = pd.read_csv('covid19_gt_10000_except_BIU (1).csv')
#cc = list(df.keys())
#del cc[0]
#del cc[0]
#Y2 = df[cc].values
#
#Y1=np.zeros([280,189],float)
#for i in range(0,280):
#    for j in range(0,189):
#        Y1[i,j]=Y2[i,j]
#Y4=np.zeros([280,189],float)
#Y4[0,:]=Y1[0,:]
#for i in range(0,189):
#    for j in range(0,279):
#        Y4[j+1,i]=np.abs(Y1[j,i]-Y1[j+1,i])         
N0=66.
def gompertz_model(x,a=0.01,b=0.1):
#    return K*np.exp(-np.log(K/N0)*np.exp(-a*x))
    return N0*np.exp(b/a)*np.exp(-(b/a)*np.exp(-a*x))
        
def fit_data_to_function(x,y,function,plot=True):
    params,_= curve_fit(function,x,y,[0.01,0.1])
    pl.plot(x,y,"go",label="observation")
    y_fit=function(x, *params)
#    print(r2_score(y,y_fit))
    if plot:
        pl.plot(x,y_fit,'bo',label="Fitted")
        pl.legend()
        pl.show()
    return params
    
#y1= Y1[0:140,101]
#y1=data 
#y2=Y4[:,89]
#y3=Y4[:,100]
#y4=Y4[:,101]
#y5=Y4[:,77]
#x1=np.arange(0,len(y1)) 
#params1= fit_data_to_function(x1,y1,gompertz_model) 
#######################################
pa=[]
for i in range(0,42):
    y2=data[0:15+i]
    x2=np.arange(len(y2))
    par=fit_data_to_function(x2,y2,gompertz_model)
    pa.append(par)
a1=[]
for i in range(0,len(pa)):
    a1.append(pa[i][0])
K1=[]
for j in range(0,len(pa)):
    K1.append(pa[i][1])
#def gompertz(x,A,u,d,v,y0):
#    y=(A*np.exp(-np.exp((((u*np.e)/A)*(d-x))+1)))+y0
#    return y
#def guess_lag(x, y):
#    """Given two axes returns a guess of the lag point.
#    The lag point is defined as the x point where the difference in y
#    with the next point is higher then the mean differences between
#    the points plus one standard deviation. If such point is not found
#    or x and y have different lengths the function returns zero.
#    """
#    if len(x) != len(y):
#        return 0
#
#    diffs = []
#    indexes = range(len(x))
#
#    for i in indexes:
#        if i + 1 not in indexes:
#            continue
#        diffs.append(y[i + 1] - y[i])
#    diffs = np.array(diffs)
#
#    flex = x[-1]
#    for i in indexes:
#        if i + 1 not in indexes:
#            continue
#        if (y[i + 1] - y[i]) > (diffs.mean() + (diffs.std())):
#            flex = x[i]
#            break
#
#    return flex
#
#
#def guess_plateau(x, y):
#    if len(x) != len(y):
#        return 0
#
#    diffs = []
#    indexes = range(len(y))
#
#    for i in indexes:
#        if i + 1 not in indexes:
#            continue
#        diffs.append(y[i + 1] - y[i])
#    diffs = np.array(diffs)
#
#    ymax = y[-1]
#    for i in indexes:
#        if y[i] > (ymax - diffs.std()) and y[i] < (ymax + diffs.std()):
#            ymax = y[i]
#            break
#
#    return ymax
#
#
#def fit(function, x, y):
#    """Fit the provided function to the x and y values.
#    The function parameters and the parameters covariance.
#    """
#    # Compute guesses for the parameters
#    # This is necessary to get significant fits
#    p0 = [guess_plateau(x, y), 4.0, guess_lag(x, y), 0.1, min(y)]
#
#    params, pcov = curve_fit(function, x, y, p0=p0)
#    return params, pcov
#
#p,q=fit(gompertz,x1,y1)           