# -*- coding: utf-8 -*-
"""
Created on Thu Sep 10 12:21:45 2020

@author: subrata
"""

from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd


#df=pd.read_csv('covid19_full.csv')
df=pd.read_csv('covid19_gt_10000_except_BIU.csv')
cc= list(df.keys())
del cc[0]
Y2 = df[cc].values
Y2=np.delete( Y2,[0,0],axis=1)

#Y1[:,np.random.permutation(Y1.shape[1])]
# x1=np.arange(0,120,1)
# x2=np.random.shuffle(x1)
# Y1=np.zeros([180,130],float)
# for i in range(0,180):
#     for j in range(0,130):
#         Y1[i,j]=Y2[i,j]
# #Y1=Y2
# for i in range(0,120):
#     for j in range(0,180):
#         Y1[j,i]=Y2[j,x1[i]]
    

trainlength=160
testlength=15
initlength=0

insize=120
outsize=10
resize = 1000
a = 0.5

#Win = (random.rand(resize,1+insize)-0.5)*1
#W= (random.rand(resize,resize)-0.5)*1
m_1=scipy.io.loadmat('Win.mat')
m_2 = scipy.io.loadmat('W.mat')

Win=m_1['Win']
W=m_2['W']
indata=Y1[:,0:insize]
outdata=Y1[:,insize:outsize+insize]

X= zeros((1+insize+resize,trainlength-initlength))
Yt= outdata[initlength:trainlength,:]
x= zeros((resize,1))
for t in range(trainlength):
    u =indata[t,:]
    u = np.reshape(u,(insize,1))
    x = (1-a)*x +a*tanh(dot(Win,vstack((1,u)) ) + dot(W,x))
    if t > initlength:
        X[:,t-initlength] = vstack((1,u,x))[:,0]
        
reg= 1e-5
X_T = X.T
Wout = dot(dot(Yt.T,X_T),linalg.inv(dot(X,X_T)+reg*eye(1+insize+resize)))

Y =zeros((outsize,testlength))  
u = indata[trainlength,:] 
u = np.reshape(u,(insize,1)) 
for t in range(testlength):
    x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
    y = dot( Wout, vstack((1,u,x)) )
    Y[:,t] = y.T
    u = indata[trainlength+t+1,:] 
    u = np.reshape(u,(insize,1))    

# pl.figure(1)
# pl.plot(Y1[161:176,120])
# pl.plot(Y[0,:])
# pl.figure(2)
# pl.plot(Y1[161:176,121])
# pl.plot(Y[1,:])
# pl.figure(3)
# pl.plot(Y1[161:176,122])
# pl.plot(Y[2,:])
# pl.figure(4)
# pl.plot(Y1[161:176,123])
# pl.plot(Y[3,:])
# pl.figure(5)
# pl.plot(Y1[161:176,124])
# pl.plot(Y[4,:])
# pl.figure(6)
# pl.plot(Y1[161:176,125])
# pl.plot(Y[5,:])
# pl.figure(7)
# pl.plot(Y1[161:176,126])
# pl.plot(Y[6,:])
# pl.figure(8)
# pl.plot(Y1[161:176,127])
# pl.plot(Y[7,:])
# pl.figure(9)
# pl.plot(Y1[161:176,128])
# pl.plot(Y[8,:])
# pl.figure(10)
# pl.plot(Y1[161:176,129])
# pl.plot(Y[9,:])
