# -*- coding: utf-8 -*-
"""
Created on Tue Sep 15 10:56:38 2020

@author: subrata
"""

from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd
from matplotlib.dates import DateFormatter
import matplotlib.ticker as ticker
from datetime import datetime
import scipy.io
import scipy.linalg
from scipy.signal import savgol_filter


df = pd.read_csv('covid19_gt_10000_except_BIU.csv')




cc = list(df.keys())
del cc[0]
del cc[0]
Y2 = df[cc].values
#x1=np.arange(0,130,1)
#x2=np.random.shuffle(x1)
#x1=np.loadtxt('random_shuffle.txt',int)
Y1=np.zeros([280,179],float)
for i in range(20,280):
    for j in range(0,179):
        Y1[i,j]=Y2[i-20,j]
Y4=np.zeros([280,179],float)
Y4[0,:]=Y1[0,:]
for i in range(0,179):
    for j in range(0,279):
        Y4[j+1,i]=np.abs(Y1[j,i]-Y1[j+1,i])  
        
y_h=[]
for i in range(0,179):
    y_h.append([])
    y_h[i]=savgol_filter(Y4[:,i],51,3)
Y3=np.zeros([280,179],float)  
for  i in range(0,179):
    for j in range(0,280):
        Y3[j,i]=y_h[i][j]         
Y5=np.zeros([260,179],float)
Y5[0,:]=Y2[0,:]
for i in range(0,179):
    for j in range(0,259):
        Y5[j+1,i]=np.abs(Y2[j,i]-Y2[j+1,i])  
        
y_h_1=[]
for i in range(0,179):
    y_h_1.append([])
    y_h_1[i]=savgol_filter(Y5[:,i],51,3)
Y6=np.zeros([260,179],float)  
for  i in range(0,179):
    for j in range(0,260):
        Y6[j,i]=y_h_1[i][j]        
#Y1=Y2
# for i in range(0,130):
#     for j in range(0,180):
#         Y1[j,i]=Y2[j,x1[i]]
# for  i in range(0,130):
#      cc[i]=(cc[x1[i]])       
#Y2 = Y1[-90:,:]
#Y1 = np.loadtxt('HR_0.10.dat',float)
#Y1 = np.transpose(Y1)
trainLen = 260
testLen = 18
initLen = 0

# generate the ESN reservoir
inSize = 169
outSize = 10
resSize = 1000
a = 0.5 # leaking rate
#random.seed(42)
Win = (random.rand(resSize,1+inSize)-0.5) * 1
W = random.rand(resSize,resSize)-0.5 
Win = (random.rand(resSize,1+inSize)-0.5) * 0.5
W = (random.rand(resSize,resSize)-0.5)*0.5 
#MSE = []
indata=Y1[:,0:169]
outdata=Y2[:,169:180]
#indata=Y2[:,0:321]
#outdata=Y2[:,321:356]

X = zeros((1+inSize+resSize,trainLen-initLen))
Yt = outdata[initLen:trainLen,:]
x = zeros((resSize,1))
for t in range(0,trainLen):
    u = indata[t,:]
    u = np.reshape(u,(169,1))
    x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
    if t > initLen:
        X[:,t-initLen] = vstack((1,u,x))[:,0]

reg = 1e-5  # regularization coefficient
X_T = X.T
Wout = dot( dot(Yt.T,X_T), linalg.inv( dot(X,X_T) + reg*eye(1+inSize+resSize) ) )

Y = zeros((outSize,testLen))
u = indata[trainLen,:]
u = np.reshape(u,(169,1))
for t in range(testLen):
    x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
    y = dot( Wout, vstack((1,u,x)) )
    Y[:,t] = y.T
    u = indata[trainLen+t+1,:] 
    u = np.reshape(u,(169,1))
#     errorLen = 5000
#     for j in range(0,8):
#         mse = sum( square( outdata[trainLen+1:trainLen+errorLen+1,j].T - Y[j,0:errorLen] ) ) / errorLen
#         MSE.append(mse)

# MSE = np.reshape(MSE,(21,8))       
#tt = np.linspace(0,400,40000)     
#pl.figure(figsize=(5,4)) 
#pl.plot(tt,Y[4,:],'dimgray',lw=1.5) # machine predicted time series
#pl.plot(tt,outdata[trainLen:trainLen+testLen,4],'r',lw=1.5) # original time series
#pl.xlabel('$t$',fontsize = 30)
#pl.ylabel('$x_{Oscillatory}$',fontsize = 30)
##pl.ylabel('$x_{Excitable}$',fontsize = 25)
#pl.xticks([0,200,400],fontsize = 20)
#pl.yticks([-2,-1,0,1,2],fontsize = 20)
##pl.title('(g)',fontsize = 20)
#pl.tight_layout()
#pl.show()
#pl.savefig('fig19.jpeg',dpi=500)
ind=(100,150,200,250,280)
days = np.arange(0,280)
for i in range(0,10):
    fig,ax = pl.subplots()
    ax.plot(days[100:260],outdata[100:260,i],'#08306b',lw=5)#, label = 'Real data')
    ax.plot(days[260:278],Y[i,:],'#e31a1c',lw=5)#, label = 'Machine Predicted')
    pl.axvline(x = 260,linewidth = 3, linestyle ="--", color ='black')
#pl.legend(bbox_to_anchor =(0.47, 0.8))
    pl.xlim(100,280)
    ax.text(0.1,0.9,cc[169+i],transform=ax.transAxes,fontsize=25)
    ax.text(0.1,0.8,'a = {}'.format(a),transform=ax.transAxes,fontsize=25)
    pl.xticks(ind,('100','150','200','250','280'),fontsize=25)
    pl.yticks(fontsize=25)
    pl.xlabel(r'days',fontsize=25)
    pl.ylabel(r'Inf',fontsize=25)
    pl.rcParams['axes.linewidth']=3
    pl.tick_params(direction= 'out', length=7,width=3)
    pl.show()
    pl.tight_layout()
