# -*- coding: utf-8 -*-
"""
Created on Sat Mar 06 12:24:34 2021

@author: subrata
"""

from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd
from matplotlib.dates import DateFormatter
import matplotlib.ticker as ticker
from datetime import datetime
import scipy.io
import scipy.linalg
from scipy.signal import savgol_filter


df = pd.read_csv('covid19_gt_10000_except_BIU_2.csv')
cc = list(df.keys())
del cc[0]
del cc[0]
Y2 = df[cc].values

l1=465
n1=241
Y1=np.zeros([l1,n1],float)
for i in range(0,l1):
    for j in range(0,n1):
        Y1[i,j]=Y2[i,j]
#210-226        
Y1[:,225]=Y2[:,91]
Y1[:,228]=Y2[:,104]  
Y1[:,229]=Y2[:,127]
Y1[:,230]=Y2[:,128]
Y1[:,232]=Y2[:,114] 
Y1[:,233]=Y2[:,221] 
Y1[:,239]=Y2[:,187] 
##
Y1[:,187]=Y2[:,239]
Y1[:,221]=Y2[:,233] 
Y1[:,114]=Y2[:,232] 
Y1[:,128]=Y2[:,230]
Y1[:,127]=Y2[:,229]
Y1[:,104]=Y2[:,228] 
Y1[:,91]=Y2[:,225]
cc[225]=cc[91]
cc[228]=cc[104]
cc[229]=cc[127]  
cc[230]=cc[128]
cc[232]=cc[114] 
cc[233]=cc[221]
cc[239]=cc[187] 
        
Y4=np.zeros([l1,n1],float)
Y4[0,:]=Y1[0,:]
for i in range(0,n1):
    for j in range(0,l1-1):
        Y4[j+1,i]=np.abs(Y1[j,i]-Y1[j+1,i])  
        
y_h=[]
for i in range(0,n1):
    y_h.append([])
    y_h[i]=savgol_filter(Y4[:,i],51,3)
Y3=np.zeros([l1,n1],float)  
for  i in range(0,n1):
    for j in range(0,l1):
        Y3[j,i]=y_h[i][j]
Y6=np.zeros([l1-14,20],float)        
for i in range(n1-20,n1):
    for j in range(0,l1-14): 
        Y6[j,i-(n1-20)]=Y3[j+14,i]

trainLen = l1-15
testLen = 14
initLen = 0

# generate the ESN reservoir
inSize = n1-20
outSize = 20
resSize = 1000
a = 0.5 # leaking rate
#random.seed(42)
N1=100
result=[]
for i in range(0,N1):
    print(i)
    Win = (random.rand(resSize,1+inSize)-0.5) * 1
    W = random.rand(resSize,resSize)-0.5 
    Win = (random.rand(resSize,1+inSize)-0.5) * 0.5
    W = (random.rand(resSize,resSize)-0.5)*0.5 

    indata=Y3[:,0:inSize]
    outdata=Y6[:,:]
   
    X = zeros((1+inSize+resSize,trainLen-initLen))
    Yt = outdata[initLen:trainLen,:]
    x = zeros((resSize,1))
    for t in range(0,trainLen):
        u = indata[t,:]
        u = np.reshape(u,(inSize,1))
        x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
        if t > initLen:
            X[:,t-initLen] = vstack((1,u,x))[:,0]

    reg = 1e-3  # regularization coefficient
    X_T = X.T
    Wout = dot( dot(Yt.T,X_T), linalg.inv( dot(X,X_T) + reg*eye(1+inSize+resSize) ) )

    Y = zeros((outSize,testLen))
    u = indata[trainLen,:]
    u = np.reshape(u,(inSize,1))
    for t in range(testLen):
        x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
        y = dot( Wout, vstack((1,u,x)) )
        Y[:,t] = y.T
        u = indata[trainLen+t+1,:] 
        u = np.reshape(u,(inSize,1))
    result.append(Y)
Q=[]
for i in range(0,20):
    Q.append([])
    for k in range(0,14):
        Q[i].append([])
        for j in range(0,N1):
            Q[i][k].append(result[j][i,k])
S=[]
for i in range(0,20):
    S.append([])
    for j in range(0,14):
        S[i].append(np.mean(Q[i][j]))
##EXTRA
df_1 = pd.read_csv('covid19_gt_10000_except_BIU.csv')
cc_1 = list(df_1.keys())
del cc_1[0]
del cc_1[0]
X2 = df_1[cc_1].values

l2=471
n2=241
X1=np.zeros([l2,n2],float)
for i in range(0,l2):
    for j in range(0,n2):
        X1[i,j]=X2[i,j]
#210-226        
X1[:,225]=X2[:,91]
X1[:,228]=X2[:,104]  
X1[:,229]=X2[:,127]
X1[:,230]=X2[:,128]
X1[:,232]=X2[:,114] 
X1[:,233]=X2[:,172] 
X1[:,239]=X2[:,187] 
##
X1[:,187]=X2[:,239]
X1[:,172]=X2[:,233] 
X1[:,114]=X2[:,232] 
X1[:,128]=X2[:,230]
X1[:,127]=X2[:,229]
X1[:,104]=X2[:,228] 
X1[:,91]=X2[:,225]
cc_1[225]=cc_1[91]
cc_1[228]=cc_1[104]
cc_1[229]=cc_1[127]  
cc_1[230]=cc_1[128]
cc_1[232]=cc_1[114] 
cc_1[233]=cc_1[172]
cc_1[239]=cc_1[187] 
        
X4=np.zeros([l2,n2],float)
X4[0,:]=X1[0,:]
for i in range(0,n2):
    for j in range(0,l2-1):
        X4[j+1,i]=np.abs(X1[j,i]-X1[j+1,i])  
        
y_h_1=[]
for i in range(0,n2):
    y_h_1.append([])
    y_h_1[i]=savgol_filter(X4[:,i],51,3)
X3=np.zeros([l2,n2],float)  
for  i in range(0,n2):
    for j in range(0,l2):
        X3[j,i]=y_h_1[i][j]     
formatter = ticker.ScalarFormatter(useMathText=True)
formatter.set_scientific(True)
formatter.set_powerlimits((0,3))
t0=np.arange(0,l1,1)
ind1=(l1-14,l1-7,l1)
for k in range(0,20):
    #pl.figure(k)
    fig,ax = pl.subplots(figsize=(6,6))
    pl.text(0.01,0.8,cc[n1-20+k],transform=ax.transAxes,fontsize=35)
    for  i in range(0,N1):
        pl.plot(t0[l1-14:l1],result[i][k,:],color='lightgray',linewidth=15)
        pl.plot(t0[l1-14:l1],S[k],color='blue',linewidth=7)
        #pl.scatter(t0[l1-14:l1-8],X4[465:471,n1-20+k],s=300,alpha=0.8,color='none',edgecolors='red',lw=4)
        pl.plot(t0[l1-14:l1-8],X3[465:471,n1-20+k],'r+',ms=15,mew=5)
        pl.xticks(ind1,('1 May','7 May','14 May'),fontsize=35)
        pl.xticks(rotation=45)
        pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
        pl.xticks(fontsize=35)
        pl.yticks(fontsize=35)
        ax.yaxis.set_major_formatter(formatter)
        ax.yaxis.offsetText.set_fontsize(35)
        pl.ylabel(r'$\mathcal{I}$',fontsize=35)
        pl.rcParams['axes.linewidth']=3
        pl.tick_params(direction= 'out', length=7,width=3)
        pl.show()
        pl.tight_layout()
        
