# -*- coding: utf-8 -*-
"""
Created on Fri Feb 26 15:16:55 2021

@author: subrata
"""

from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd
from matplotlib.dates import DateFormatter
import matplotlib.ticker as ticker
from datetime import datetime
from scipy.optimize import curve_fit
import scipy.io
import scipy.linalg
from scipy.stats import gompertz
#from sklearn.metrics import r2_score
from scipy.signal import savgol_filter

data=np.loadtxt('china_data.txt',float)
df = pd.read_csv('covid19_gt_10000_except_BIU (1).csv')
cc = list(df.keys())
del cc[0]
del cc[0]
Y2 = df[cc].values

Y1=np.zeros([280,189],float)
for i in range(0,280):
    for j in range(0,189):
        Y1[i,j]=Y2[i,j]
Y4=np.zeros([280,189],float)
Y4[0,:]=Y1[0,:]
for i in range(0,189):
    for j in range(0,279):
        Y4[j+1,i]=np.abs(Y1[j,i]-Y1[j+1,i])  
        
y_h=[]
for i in range(0,189):
    y_h.append([])
    y_h[i]=savgol_filter(Y4[:,i],51,3)
Y3=np.zeros([280,189],float)  
for  i in range(0,189):
    for j in range(0,280):
        Y3[j,i]=y_h[i][j] 
N0=1000.
def gompertz_model(x,a=1,K=5000):
#    return N0*np.exp(b/a)*np.exp(-(b/a)*np.exp(-a*x))
    return a*K*np.exp(-np.log(K/N0)*np.exp(-a*x))*(np.log(K/N0)*np.exp(-a*x))
        
def fit_data_to_function(x,y,function,plot=True):
    params,_= curve_fit(function,x,y,[1,5000])
    pl.plot(x,y,"go",label="observation")
    y_fit=function(x, *params)
#    print(r2_score(y,y_fit))
    if plot:
        pl.plot(x,y_fit,'bo',label="Fitted")
        pl.legend()
        pl.show()
    return params
    
y1= Y3[215:258,100]
#y1=data 
#y2=Y4[:,89]
#y3=Y4[:,100]
#y4=Y4[:,101]
#y5=Y4[:,77]
#x1=np.arange(0,len(y1)) 
#params1= fit_data_to_function(x1,y1,gompertz_model) 
#######################################
pa=[]
for i in range(0,170):
    y2=y1[0:58+i]
    x2=np.arange(len(y2))
    par=fit_data_to_function(x2,y2,gompertz_model)
    pa.append(par)
a1=[]
for i in range(0,len(pa)):
    a1.append(pa[i][0])
K1=[]
for j in range(0,len(pa)):
    K1.append(pa[i][1])
#t=np.arange(0,230)
#N_n=[pa[-1][0]*pa[-1][1]*np.exp(-np.log(pa[-1][0]/N0)*np.exp(-pa[-1][0]*x))*(np.log(pa[-1][1]/N0)*np.exp(-pa[-1][0]*x)) for x in t]    
#pl.figure(2)
#pl.plot(np.arange(0,230),Y4[20:250,101],'go')
#pl.plot(t,N_n,'bo')