# -*- coding: utf-8 -*-
"""
Created on Sat Sep 26 22:00:11 2020

@author: A Mishra
"""

import numpy as np
import pylab as pl
import matplotlib.colors as colors
from matplotlib import ticker, cm

a = np.loadtxt('MSE_ep.txt',float)
ind=(0,2500,5000)
ind1=(10**-9,10**-5,10**-2,0.1,0.25)
fig, ax = pl.subplots()
#colorsList = ['#252525','#636363','#969696','#bdbdbd','#d9d9d9','#f7f7f7']
# colorsList = ['b','limegreen','r','yellow']
colorsList = ['lightskyblue','deepskyblue','blue','navy']
CustomCmap = colors.ListedColormap(colorsList)
bounds = np.array([1e-9, 1e-5,1e-2,0.1,0.25])
norm = colors.BoundaryNorm(boundaries=bounds, ncolors=4)
cax = ax.imshow(a,aspect='auto',origin='lower',extent=[0,50,0,5000],cmap=CustomCmap, norm = norm)
pl.xlabel('N', fontsize=30)
pl.ylabel('t',fontsize=30)
pl.xticks(fontsize=20)
pl.yticks(ind,('0','25','50'),fontsize=20)
# cbar = fig.colorbar(cax, ticks=[1e-9, 1e-5, 1e-2,0.1,0.25])#orientation='horizontal')
# cbar.ax.set_xticklabels(['$10^{-9}$', '$10^{-5}$','$10^{-2}$','$10^{-1}$','0.25'],size=20) 
cbar = fig.colorbar(cax, ticks=[1e-9, 1e-5, 1e-2,0.1,0.25])
cbar.ax.set_yticklabels(['$10^{-9}$', '$10^{-5}$','$10^{-2}$','$10^{-1}$','$0.25$'],fontsize=20) 
#pl.colorbar()
cbar.ax.tick_params(direction= 'out', length=4,width=2)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'out', length=4,width=2)
pl.tight_layout()