# -*- coding: utf-8 -*-
"""
Created on Tue Sep 15 11:49:38 2020

@author: subrata
"""


from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd

N1=100
#df=pd.read_csv('covid19_full.csv')
df=pd.read_csv('covid19_gt_10000_except_BIU.csv')
cc= list(df.keys())
del cc[0]
Y2 = df[cc].values
Y2=np.delete( Y2,[0,0],axis=1)

#Y1[:,np.random.permutation(Y1.shape[1])]
result=[]
for i in range(0,N1):
    print(i)
    x1=np.arange(0,169,1)
    x2=np.random.shuffle(x1)
    Y1=np.zeros([260,179],float)
    for i in range(0,260):
        for j in range(0,179):
            Y1[i,j]=Y2[i,j]
            
    for i in range(0,169):
        for j in range(0,260):
            Y1[j,i]=Y2[j,x1[i]]
    

    trainlength=240
    testlength=15
    initlength=0

    insize=169
    outsize=10
    resize = 1000
    a = 0.5

    Win = (random.rand(resize,1+insize)-0.5)*1
    W= (random.rand(resize,resize)-0.5)*1

    indata=Y1[:,0:insize]
    outdata=Y1[:,insize:outsize+insize]

    X= zeros((1+insize+resize,trainlength-initlength))
    Yt= outdata[initlength:trainlength,:]
    x= zeros((resize,1))
    for t in range(trainlength):
        u =indata[t,:]
        u = np.reshape(u,(insize,1))
        x = (1-a)*x +a*tanh(dot(Win,vstack((1,u)) ) + dot(W,x))
        if t > initlength:
            X[:,t-initlength] = vstack((1,u,x))[:,0]
        
    reg= 1e-5
    X_T = X.T
    Wout = dot(dot(Yt.T,X_T),linalg.inv(dot(X,X_T)+reg*eye(1+insize+resize)))

    Y =zeros((outsize,testlength))  
    u = indata[trainlength,:] 
    u = np.reshape(u,(insize,1)) 
    for t in range(testlength):
        x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
        y = dot( Wout, vstack((1,u,x)) )
        Y[:,t] = y.T
        u = indata[trainlength+t+1,:] 
        u = np.reshape(u,(insize,1))    
    result.append(Y)
    
Q=[]
for i in range(0,10):
    Q.append([])
    for k in range(0,15):
        Q[i].append([])
        for j in range(0,N1):
            Q[i][k].append(result[j][i,k])
S=[]
for i in range(0,10):
    S.append([])
    for j in range(0,15):
        S[i].append(np.mean(Q[i][j]))
        
            
    
# ind=(100,120,140,160,180)
# t0=np.arange(0,180,1)
# for k in range(0,10):
#     pl.figure(k)
#     for  i in range(0,N1):
#         pl.plot(S[k],color='grey',linewidth=3)
#         #pl.plot(result[i][k,:],'.',color='grey',linewidth=3)
#         pl.plot(Y1[161:176,120+k],color='r')
#         pl.xticks(fontsize=25)
#         pl.yticks(fontsize=25)
#         pl.xlabel(r'days',fontsize=25)
#         pl.ylabel(r'Inf',fontsize=25)
#         pl.rcParams['axes.linewidth']=3
#         pl.tick_params(direction= 'out', length=7,width=3)
#         pl.show()
#         pl.tight_layout()

ind=(100,140,180,220,260)
t0=np.arange(0,260,1)
for k in range(0,10):
    pl.figure(k)
    pl.plot(S[k],color='grey',linewidth=3)
    pl.plot(Y1[241:256,169+k],color='r')
    pl.xticks(fontsize=25)
    pl.yticks(fontsize=25)
    pl.xlabel(r'days',fontsize=25)
    pl.ylabel(r'Inf',fontsize=25)
    pl.rcParams['axes.linewidth']=3
    pl.tick_params(direction= 'out', length=7,width=3)
    pl.show()
    pl.tight_layout()
