# -*- coding: utf-8 -*-
"""
Created on Sat Nov 21 10:50:32 2020

@author: subrata
"""



from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd
from matplotlib.dates import DateFormatter
import matplotlib.ticker as ticker
from datetime import datetime
import scipy.io
import scipy.linalg
from scipy.signal import savgol_filter


df = pd.read_csv('covid19_gt_10000_except_BIU (1).csv')
cc = list(df.keys())
del cc[0]
del cc[0]
Y2 = df[cc].values

Y1=np.zeros([280,189],float)
for i in range(0,280):
    for j in range(0,189):
        Y1[i,j]=Y2[i,j]
        
Y1[:,179]=Y2[:,85]
Y1[:,180]=Y2[:,89]  
Y1[:,181]=Y2[:,100]
Y1[:,183]=Y2[:,101] 
Y1[:,187]=Y2[:,77]  
Y1[:,85]=Y2[:,179]
Y1[:,89]=Y2[:,180]  
Y1[:,100]=Y2[:,181]
Y1[:,101]=Y2[:,183]
Y1[:,77]=Y2[:,187] 
cc[179]=cc[85]
cc[180]=cc[89]
cc[181]=cc[100]  
cc[183]=cc[101]
cc[187]=cc[77]  
        
Y4=np.zeros([280,189],float)
Y4[0,:]=Y1[0,:]
for i in range(0,189):
    for j in range(0,279):
        Y4[j+1,i]=np.abs(Y1[j,i]-Y1[j+1,i])  
        
y_h=[]
for i in range(0,189):
    y_h.append([])
    y_h[i]=savgol_filter(Y4[:,i],51,3)
Y3=np.zeros([280,189],float)  
for  i in range(0,189):
    for j in range(0,280):
        Y3[j,i]=y_h[i][j]
Y6=np.zeros([265,11],float)        
for i in range(178,189):
    for j in range(0,265): 
        Y6[j,i-178]=Y3[j+15,i]

trainLen = 250
testLen = 15
initLen = 0

# generate the ESN reservoir
inSize = 178
outSize = 11
resSize = 1000
a = 0.5 # leaking rate
#random.seed(42)
Win = (random.rand(resSize,1+inSize)-0.5) * 1
W = random.rand(resSize,resSize)-0.5 
Win = (random.rand(resSize,1+inSize)-0.5) * 0.5
W = (random.rand(resSize,resSize)-0.5)*0.5 

indata=Y3[:,0:inSize]
outdata=Y6[:,:]


X = zeros((1+inSize+resSize,trainLen-initLen))
Yt = outdata[initLen:trainLen,:]
x = zeros((resSize,1))
for t in range(0,trainLen):
    u = indata[t,:]
    u = np.reshape(u,(inSize,1))
    x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
    if t > initLen:
        X[:,t-initLen] = vstack((1,u,x))[:,0]

reg = 1e-3  # regularization coefficient
X_T = X.T
Wout = dot( dot(Yt.T,X_T), linalg.inv( dot(X,X_T) + reg*eye(1+inSize+resSize) ) )

Y = zeros((outSize,testLen))
u = indata[trainLen,:]
u = np.reshape(u,(inSize,1))
for t in range(testLen):
    x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
    y = dot( Wout, vstack((1,u,x)) )
    Y[:,t] = y.T
    u = indata[trainLen+t+1,:] 
    u = np.reshape(u,(inSize,1))


#ind=(250,255,260,265)
##ind2=(0,500,1000,1500,2000,2500,3000)
#
#days = np.arange(0,265)
#for i in range(0,11):
#    fig,ax = pl.subplots(figsize=(10,10))
#    ax.plot(days[trainLen:265],outdata[trainLen:265,i],'#08306b',lw=7)#, label = 'Real data')
#    ax.plot(days[trainLen:265],Y[i,0:testLen],'r--',lw=5)#, label = 'Machine Predicted')
#    ax.scatter(days[trainLen:265:2],Y[i,0:testLen:2],s=300,color='none',edgecolors='red',lw=6)
#
#    ax.yaxis.offsetText.set_fontsize(55)
##    ax.yaxis.set_major_locator(ticker.MultipleLocator(300))
#    #pl.axvline(x = 240,linewidth = 2.5, linestyle ="--", color ='black')
##pl.legend(bbox_to_anchor =(0.47, 0.8))
#    pl.xlim(250,265)
#    ax.text(0.1,0.8,cc[inSize+i],transform=ax.transAxes,fontsize=55)
#    #ax.text(0.1,0.8,'a = {}'.format(a),transform=ax.transAxes,fontsize=30)
#    pl.xticks(ind,('265','270','275','280'),fontsize=60)
#    pl.xticks(rotation=45)
#    pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
#    pl.yticks(fontsize=55)
#    #pl.xlabel(r'$t$',fontsize=65)
#    pl.ylabel(r'$\mathcal{I}$',fontsize=65)
#    pl.rcParams['axes.linewidth']=3
#    pl.tick_params(direction= 'out', length=7,width=3)
#    pl.show()
#    pl.tight_layout()

ind1=(0,120,258)
days = np.arange(0,260)
for i in range(0,11):
    fig,ax = pl.subplots(figsize=(10,10))
    ax.plot(days[0:260],outdata[0:260,i],'#08306b',lw=12)#, label = 'Real data')
    ax.plot(days[240:260],Y[i,0:20],'r--',lw=12)#, label = 'Machine Predicted')
    #ax.scatter(days[258:279:3],Y[i,0:21:3],s=100,color='none',edgecolors='red',lw=6)

    ax.yaxis.offsetText.set_fontsize(55)
    #ax.yaxis.set_major_locator(ticker.MultipleLocator(2200))
    pl.axvline(x = 240,linewidth = 6, linestyle ="--", color ='black')
#pl.legend(bbox_to_anchor =(0.47, 0.8))
    pl.xlim(240,260)
    ax.text(0.1,0.8,cc[178+i],transform=ax.transAxes,fontsize=55)
    #ax.text(0.1,0.8,'a = {}'.format(a),transform=ax.transAxes,fontsize=30)
    pl.xticks(ind1,('22 Jan','20 May','5 Oct'),fontsize=60)
#    pl.rcParams['axes.facecolor'] = 'g'
    pl.axvspan(240,260,facecolor='silver')
    pl.xticks(rotation=45)
    pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
    pl.yticks(fontsize=55)
#    pl.xlabel(r'$t$',fontsize=65)
    pl.ylabel(r'$\mathcal{I}$',fontsize=65)
    pl.rcParams['axes.linewidth']=3
    pl.tick_params(direction= 'out', length=7,width=3)
    pl.show()
    pl.tight_layout()    
    
