# -*- coding: utf-8 -*-
"""
Created on Sat Sep 19 23:12:13 2020

@author: subrata
"""



### SIR model to find the maximum infection time
import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import scipy.io
import networkx as nx
import pandas as pd
from scipy.signal import savgol_filter


N = 1000
mat1 = scipy.io.loadmat('beta_S0.mat')
B = mat1['Beta']

def f(y,t):
    dy = np.empty(2*N,float)
    u = y[0:2*N:2]
    v = y[1:2*N+1:2]

    for i in range(0,N):
        dy[2*i] = (-B[0][i]*u[i]*v[i] ) 
        dy[2*i+1] =( B[0][i]*u[i]*v[i] - P*v[i] ) 
    return dy
#B =np.loadtxt('beta.txt',float)
P =1./14
tf = 300
y0 = np.zeros(2*N,float)
init = mat1['S0_init']
y0[0:2*N:2] = init[0][:]
#y0[1:2*N+1:2]= np.random.uniform(0.000001,0.000008,N) 
y0[1:2*N+1:2]= 1.- y0[0:2*N:2]
#y0[0:2*N:2] = 1 - y0[1:2*N+1:2] 
t1= np.linspace(0, tf, tf*100 )
[sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1) 
S=np.zeros([29999,N],float)
S[0,:]=y0[1:2*N+1:2]
#S=[]
for i in range(0,N):
    for j in range(0,29998):
        S[j+1,i]=(S[j,i]+sol1[j+1,2*i+1])
       # S[i].append(np.sum(sol1[j+1,2*i+1]))
       
df = pd.read_csv('covid19_gt_10000_except_BIU.csv')
cc = list(df.keys())
del cc[0]
del cc[0]
Y2 = df[cc].values

Y1=np.zeros([260,179],float)
for i in range(0,260):
    for j in range(0,179):
        Y1[i,j]=Y2[i,j]
Y2=np.zeros([260,179],float)
Y2[0,:]=Y1[0,:]
for i in range(0,179):
    for j in range(0,259):
        Y2[j+1,i]=np.abs(Y1[j,i]-Y1[j+1,i]) 
y_h=[]
for i in range(0,179):
    y_h.append([])
    y_h[i]=savgol_filter(Y2[:,i],51,3)
Y3=np.zeros([260,179],float)  
for  i in range(0,179):
    for j in range(0,260):
        Y3[j,i]=y_h[i][j]
 